/**
 * Write details of this program here, and add your name and
 * a version number in the parentheses below.
 * 
 * @author () 
 * @version ()
 */
import java.util.*;
public class TictacToe
{
    public static void main()
    {
        Board game= new Board();       // Initialise the game and user input
        Scanner scan= new Scanner(System.in);
        
        boolean userFirst= true;
        
        System.out.println("Welcome to the game of Tic Tac Toe.");
        System.out.println("You will play the noughts and I will play crosses.");
        
        // Find out if the user wants to start first or not
        while (true)
        {
          System.out.print("Would you like to start first (y or n): ");
          String line= scan.nextLine();
          char yesNo= line.charAt(0);
          if ((yesNo=='y') || (yesNo=='Y'))
          {
              userFirst= true;
              break;
          }
          if ((yesNo=='n') || (yesNo=='N'))
          {
              userFirst= false;
              break;
          }
          System.out.println("I don't understand that! Try again.");
        }
        
        // Make a random move if it's our turn to start with
        if (userFirst == false)
           game.makeMove(1 + (int)Math.floor(Math.random() * 9), 'X');
        
        // Game's main loop. Ask the user for a new move.
        // Make the move. See if the user won. If not,
        // we get to make a move with alphaBeta. See if we won.
        while (true)
        {
          getUserMove(game, scan);
          if (game.hasWon('O'))
          {
              System.out.println(game);
              System.out.println("Congratulations! You've won!");
              break;
          }
          
          // OK, the user has not won. We can make a move now.
          // For now, make a random move.
          while (true)
          {
              int move= 1 + (int)Math.floor(Math.random() * 9);
              if (game.makeMove(move, 'X')==true)
                break;
          }
          
          // If we won, tell them and leave the loop.
          if (game.hasWon('X'))
          {
              System.out.println(game);
              System.out.println("Well, it looks like I've beaten you.");
              break;
          }
        }
    }
    
    
    
    /*
     * Method to show the current board to the user, prompt them
     * for a move, and make the move on the board. The user
     * is continually prompted until they choose a valid move.
     */
    public static void getUserMove(Board game, Scanner s)
    {
        System.out.println(game);
        
        while (true)
        {
            System.out.print("Your move (1 to 9): ");
            int move= s.nextInt();
            
            // If the move is valid, return
            if (game.makeMove(move, 'O')==true)
               return;
            System.out.println("That move is invalid. Try again.");
        }
    }
}
