package ArjenDB;
use strict;
use warnings;
use DBI;
use File::Basename;
use Cwd 'abs_path';

BEGIN {
    use Exporter ();
    use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);

    @ISA         = qw(Exporter);
    @EXPORT      = qw(h);
    %EXPORT_TAGS = ();
    @EXPORT_OK   = qw();
}

# Get proper basedir
my $dirname = abs_path ( dirname ( __FILE__ ) );

# Database connection handle
my $dbh = DBI -> connect ( "dbi:SQLite:dbname=$dirname/arjen.db","","" ) or die "Unable to open arjen database '$dirname/arjen.db': $!";

sub h {
    return $dbh;
}

END { 
    # module clean-up code here (global destructor)
    $dbh -> disconnect; 
}    

1;
