#!/usr/bin/perl
use strict;
use warnings;
use lib '..';
use Arjen;
use JSON;
use CGI;

my $q = CGI -> new;

print $q -> header ( 'application/json' );

my $utoken = $q -> param ( 'user' ) or undef;
my $source = $q -> param ( 'source' ) or undef;
my $storeSource = $q -> param ( 'store_source' ) or undef;

print ( encode_json { state => "fail", error => "No source given" } ) and exit 0 if not defined $source or $source =~ /^\s*$/;

$utoken =~ s/(^\s*|\s*$)// if defined $utoken;
$utoken = undef if not $utoken;
my $errors = checkSource ( $source, $utoken, $storeSource, $ENV{"REMOTE_ADDR"} );

print encode_json { state => "ok", errors => $errors };

exit 0;
